using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            int size = Marshal.SizeOf(typeof(RawInputDevice));
            RawInputDevice[] devices = new RawInputDevice[1];
            // UsagePage=1,Usage=2 Ń}EXfoCXw
            devices[0].UsagePage = 1;
            devices[0].Usage = 2;
            //WM_INPUT 󂯎EBhE
            devices[0].Target = this.Handle;
            //WM_INPUT LɂfoCXQAdevices ̐A
            //  RawInputDevice ̍\̃TCY
            RegisterRawInputDevices(devices, 1, size);
            this.Capture = true;
        }

        private void ProcessInputKey(ref Message m)
        {
            const int RidInput = 0x10000003;
            int headerSize = Marshal.SizeOf(typeof(RawInputHeader));
            int size = Marshal.SizeOf(typeof(RawInput));
            RawInput input;
            GetRawInputData(m.LParam, RidInput, out input,
                            ref size, headerSize);
            RawMouse mouse = input.Mouse;
            this.textBox1.AppendText(
                //foCX̔ԍƒÖړʂ\
                string.Format("{0}({1},{2})\r\n",
                              input.Header.Device,
                              mouse.LastX, mouse.LastY));

        }

        protected override void WndProc(ref Message m)
        {
            const int WmInput = 0xFF;
            if (m.Msg == WmInput)
                this.ProcessInputKey(ref m);
            base.WndProc(ref m);
        }

        [DllImport("user32.dll")]
        private static extern int RegisterRawInputDevices(
            RawInputDevice[] devices, int number, int size);
        [DllImport("user32.dll")]
        private static extern int GetRawInputData(
            IntPtr rawInput, int command, out RawInput data,
            ref int size, int headerSize);

        private struct RawInputDevice
        {
            public short UsagePage;
            public short Usage;
            public int Flags;
            public IntPtr Target;
        }
        private struct RawInputHeader
        {
            public int Type;
            public int Size;
            public IntPtr Device;
            public IntPtr WParam;
        }
        private struct RawInput
        {
            public RawInputHeader Header;
            public RawMouse Mouse;
        }
        private struct RawMouse
        {
            public short Flags;
            public short ButtonFlags;
            public short ButtonData;
            public int RawButtons;
            public int LastX;
            public int LastY;
            public int Extra;
        }



    }
}